//
//  BundleItem.c
//  file-folder
//
//  Created by kunii on 2014/01/18.
//  Copyright (c) 2014年 國居貴浩. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include "BundleItem.h"

static FolderItem* super = NULL;

//  itemで指定されるItem構造体の名前をコンソールに表示する。
//  内包するファイルやフォルダは表示しない。
static void printBundleItem(Item* item, int indent)
{
    //  indentで指定される数だけ半角スペースを表示してから名前を表示する。
    for (int i = 0; i < indent; i++) printf(" ");
    printf("[%s]\n", item->name);   //  ファイルなので名前を []　で囲んでから表示
}

Item* BundleItemAlloc()
{
    if (super == NULL)
        super = (FolderItem*)FolderItemAlloc();
    Item* item = malloc(sizeof(BundleItem));
    *((FolderItem*)item) = *super;              //  FolderItem構造体に設定された関数ポインタがコピーされる
    BundleItem* bundleItem = (BundleItem*)item;
    bundleItem->printContents = item->print;	//  フォルダのprintはバンドルのprintContentsに移動
    item->print = printBundleItem;              //  バンドル専用の表示関数を指定
    return item;
}

