//
//  main.c
//  file-folder
//
//  Created by kunii on 2014/01/18.
//  Copyright (c) 2014年 國居貴浩. All rights reserved.
//

#include <stdio.h>
#include "FileItem.h"
#include "FolderItem.h"
#include "BundleItem.h"

int main(int argc, const char * argv[])
{
    //  rootフォルダ作成、初期化
    Item* root = BundleItemAlloc();
    root->init(root, "root");
    
    //  folderAフォルダ作成、初期化
    Item* folderA = FolderItemAlloc();
    folderA->init(folderA, "folder A");
    
    //  folderBフォルダ作成、初期化
    Item* folderB = FolderItemAlloc();
    folderB->init(folderB, "folder B");
    
    //  rootフォルダにfolderA、folderBを内包させる
    ((FolderItem*)root)->add((FolderItem*)root, folderA);
    ((FolderItem*)root)->add((FolderItem*)root, folderB);

    //  fileAファイル作成、初期化
    Item* fileA = FileItemAlloc();
    fileA->init(fileA, "file A");
    
    //  rootフォルダにfileAを内包させる
    ((FolderItem*)root)->add((FolderItem*)root, fileA);
    
    //  印刷
    root->print(root, 0);
    
    //  内容部印刷
    printf("\nShow Contents\n");
    ((BundleItem*)root)->printContents(root, 0);
    
    //  破棄
    root->dealloc(root);
    return 0;
}